/* GE proc to select first stage size in the Bonferroni Procedure */

proc(1) = fstage(delta);
local a1;

delta=abs(delta);

if delta<0.5;
  {a1}=lint(delta,0.50|0.30,0|0.5);
  elseif delta<0.7;
  {a1}=lint(delta,0.30|0.22,0.5|0.7);
  elseif delta<0.9;
  {a1}=lint(delta,0.22|0.13,0.7|0.9);
  else;
  {a1}=lint(delta,0.13|0.1,0.9|1);
endif;

a1=round(100*a1)/100;
if a1.>0.4; a1=0.4; endif;
retp(a1);
endp;

@fstage(0.9);@
