library pgraph;
/* mcg1.prc GE 4/92 procedure to generate (y,x) for the sequential
   testing project   - modified 8/93 so that a I(1) instrament
   z is also given for ces project */

proc(3) = mcg1(rho,lambda,beta,nobs,nst);
local sig9, sig9chol, nobs9, eps, x9, x91,
      y9, zeps, z9, y, x, z;

@ ---- calculate correlated residuals -----@
sig9=eye(2);
if abs(lambda)/=1;
 sig9[1,2]=lambda;sig9[2,1]=lambda;
 sig9chol=chol(sig9);
else;
sig9chol=(1~0|lambda~0);
endif;
nobs9=nobs+nst+3;  @sig9chol;@
eps=rndn(2,nobs9);
eps=sig9chol'*eps;   @ (eps*eps')/cols(eps);@

@--- generate x variable -------@

x9=recserar(eps[1,.]',eps[1,1],rho);
x91=(0)|x9[1:rows(x9)-1,.];



@--- generate y variable -------@
y9=beta.*x91+(eps[2,.]');

zeps=rndn(nobs9,1);
z9=recserar(zeps,zeps[1,1],1);

 y=y9[(rows(x9)-nobs-1):rows(x9)-2,1];
 x=x9[(rows(x9)-nobs-1):rows(x9)-2,1];
 z=z9[(rows(z9)-nobs-1):rows(z9)-2,1];

retp(y,x,z);
endp;
@--------------------------------------------------------@

@ debug @
@{y,x,z}= mcg1(1,0.5,0,100,2);@

